
-- ************************
-- * Variable Declaration *
-- ************************

local alertframe, cfflag, ddmenu, clmenu, pname, pflag, itemlink = nil, nil, nil, nil, nil, nil
local mouse, buttons = false, false
local inactive, combat = false, false
local tradechannel = -1
local _G = _G
local eventframe = nil
local events = {}
local matchedval = nil
local kicked = nil
local ENTERING = false
local addonChNumber = nil
LibStub("AceTimer-3.0"):Embed(LFMonitor)
local me = GetUnitName("player", false)

-- print("LFMonitor.lua start")
local testFiltering = false
local logFiltering = false
local addonChannelName = "LFML"
local addonChannelDesc = "LFML"

local raidsByMapid = {
	-- Classic
	["229"] = "UBRS",
	["309"] = "ZG", -- backward compatibility?
	["409"] = "MC",
	["469"] = "BWL",
	["509"] = "AQ10",
	["531"] = "AQ40",
	["532"] = "Kra",
	["533"] = "Nax",
	["534"] = "Hyj",
	-- BC
	["544"] = "Mag",
	["548"] = "SSC",
	["550"] = "TK",
	["564"] = "BT",
	["565"] = "GL",
	["580"] = "SWP",

	-- WotLK
	["603"] = "Uld",
	["615"] = "OS",
	["616"] = "EoE",
	["631"] = "ICC",
	-- Cata
	["568"] = "ZA",
	-- 644 = HoO
	-- 645 = BRC
	-- 657 = VP
	["669"] = "BWD",
	["671"] = "BoT",
	["720"] = "FL",
	-- 725 = SC
	["754"] = "TFW",
	["757"] = "BH",
	["859"] = "ZG",
}

function LFMonitor:setTestFiltering(value)
	testFiltering = value
end

function LFMonitor:setLogFiltering(value)
	if not LFMonitorLog then
		LFMonitorLog = {}
	end
	logFiltering = value
end

local function JoinChannel()
  JoinTemporaryChannel(addonChannelName, addonChannelDesc)
  SetChannelPassword(addonChannelName, addonChannelDesc)
end

local function JoinChannelIfNeeded()
--  print("JoinChannelIfNeeded running")
  if(ENTERING) then
    JoinChannel();
    ENTERING = false
  end

  if(kicked) then
    JoinChannel();
    kicked = nil;
  end
end

-- The following code is adapted from r61 of Misspelled, downloaded from
-- http://wow.curse.com/downloads/wow-addons/details/misspelled/download/526785.aspx

--Local reference to Global functions for speed
local string_find = string.find
local table_insert = table.insert
local string_len = string.len
local string_sub = string.sub
local string_split = string.split
local string_gsub = string.gsub
local string_match = string.match
local string_gmatch = string.gmatch
local string_format = string.format
local raw_lower = string.lower
local string_lower = function(s)
	return string_gsub(raw_lower(s),"'","")
end
local string_upper =  string.upper
local math_min = math.min
local math_abs = math.abs
local math_max = math.max
local math_random = math.random
local fuzzy = LFMonitor.words.fuzzy
local fuzzyByLength = LFMonitor.words.fuzzyByLength
local exact = LFMonitor.words.exact

--split a string, at delimiter into a table
-- Compatibility: Lua-5.1
local split_t
local split_fpat
local split_last_end
local split_s, split_e, split_cap

local rows = {
	{ 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15},
	{ 1,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{ 2,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{ 3,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{ 4,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{ 5,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{ 6,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{ 7,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{ 8,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{ 9,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{10,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{11,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{12,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{13,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{14,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0},
	{15,0,0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0}
}
function wordSimilarity(source, target, distanceFactor)
	local i, j, ci, cj, il

	local m = string_len(source)
	local n = string_len(target)

	local substitutionCost

	for i=2, m do
		ci = string_sub(source, i-1, i-1)
		for j=2,n do
			cj = string_sub(target, j-1, j-1)
			if ci == cj then
				substitutionCost = 0
			else
				il = (ci >= 'a' and ci <= 'z')
				jl = (cj >= 'a' and cj <= 'z')
				if (il and jl) or (not il and not jl) then
					substitutionCost = 1.5
				else
					substitutionCost = 3
				end
			end

			rows[i][j] = math_min(	rows[i-1][j] + 1, 					--Insertion
									rows[i][j-1] + 1, 					--Deletion
									rows[i-1][j-1] + substitutionCost)	--Substitution
		end
	end

	local dist = rows[m][n]

	return math_max(1 - dist*distanceFactor, 0)
end

-- end of adapted code

-- *****************
-- * Filter Engine *
-- *****************

--replace links with the link text
local function unlink(msg)
	return string_gsub(msg, "|c%x+|H[^|]+|h%[([^|]+)%]|h|r","%1")
end

--function to remove {star},{square} etc. so we don't waste time classifying them as words
local function formatspecial(msg)

	return string_gsub(msg, "{[%a%d]*}", " ")

end

local function doSearch(_, msgTxt, typeTxt)
	msgTxt = unlink(msgTxt)
	local pattern
	for pattern in typeTxt do
		if(string_match(msgTxt,pattern)) then
			return true
		end
		return false
	end
end

-- ***********************
-- * Debug Functions *
-- ***********************

local function debug(msg)
	if testFiltering then
		DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 0, 0)
	end
end

-- **********************************************
-- * Fuzzy matching & classifier implementation *
-- **********************************************

local function cacheLookup(table, item, fallback, disableCaching)
  assert(item, "cacheLookup called with nil item")
  if disableCaching then
    return fallback(item)
  end
--  local n
--  if not table.item then
--    table.item = {}
--	for n=1,table.max do
--	  table.item[n] = false
--	end
--  end
  if not table.score then
    table.score = {}
--	for n=1,table.max do
--	  table.score[n] = false
--	end
  end
--  local hashKey = math.fmod(StringHash(item), table.max) + 1
--  if table.item[hashKey] == item and table.score[hashKey] then
--	debug("cacheLookup found entry "..tostring(table.score[hashKey]).." for item "..item)
--	return table.score[hashKey]
  if table.score[item] then
	return table.score[item]
  else
	local score = fallback(item)
--	debug("cacheLookup stored result "..tostring(score).." for item "..item)
--	table.item[hashKey] = item
	table.score[item] = score
	if table.count >= table.max then
		table.score[next(table.score)] = nil
	else
		table.count = table.count + 1
	end
	return score
  end
end

local function fuzzyWordMatch(currentWord)
  local fuzzy = fuzzy
  local exact = exact
  local length = string_len(currentWord)
  if length < 3 or length > 15 then
	-- don't match 1- or 2-letter abbrs inexactly, and don't
	  -- waste CPU cycles on words that are too long to match anything
	return {{},{}}
  end
  local fuzzyByLength = fuzzyByLength[length-2]
  local matches = {}
  local strengths = {}
  local matchStrength = 0
  for candidateWord, distanceFactor in pairs(fuzzyByLength) do
	matchStrength = wordSimilarity(currentWord,candidateWord,distanceFactor)
	if matchStrength > 0 then
		tinsert(matches,candidateWord)
		tinsert(strengths,matchStrength)
	end
  end
  return {matches,strengths}
end

local function cachingWordMatch(currentWord, disableCaching)
  if exact[currentWord] then
--    debug("Found exact word match in LFMonitor.words.exact for "..currentWord)
	return {{currentWord},{'e'}}
  elseif fuzzy[currentWord] then
--    debug("Found exact word match in LFMonitor.words.fuzzy for "..currentWord)
    return {{currentWord},{1}}
  end
  return cacheLookup(LFMonitorWordCache, currentWord, fuzzyWordMatch, disableCaching)
end

local function classifyMessage(message, disableCaching)
  local words = {}
  local result = {
	["type"] = {
		["lfprof"] = 0,
		["lfw"] = 0,
		["lfm"] = 0,
		["lfg"] = 0,
		["wtb"] = 0,
		["wts"] = 0,
		["lfguild"] = 0,
		["guildlfm"] = 0
	},
	["class"] = {},
	["raid"] = {},
	["role"] = {},
	["prof"] = {}
  }
  assert(message,"classifyMessage called with nil message")
  local matches = {}
  local wordCount = 0
  local i, match, strength, entry, matchedwords, scores, classtype, classes, class, score, highestScore
  for word, entry in pairs(LFMonitor.patterns) do
	if string_find(message, word) then
		debug("Pattern match: "..word)
		for classtype, classes in pairs(entry) do
			for class, score in pairs(classes) do
				result[classtype][class] = (result[classtype][class] or 0) + score
			end
		end
	end
  end
  message = string_lower(formatspecial(unlink(message)))
  for word in string_gmatch(message, LFMonitor.WORD_PATTERN) do
    wordCount = wordCount + 1
	matchedwords, scores = unpack(cachingWordMatch(word, disableCaching))
	for i=1,#matchedwords do
		if scores[i] == 'e' then
			matches[matchedwords[i]] = 'e'
		elseif matches[matchedwords[i]] ~= 'e' then
			matches[matchedwords[i]] = math_max(matches[matchedwords[i]] or 0, scores[i])
		end
	end
    if timedout then break end
  end
  if wordCount <= 2 then
    return  {
		["type"] = {
			["lfprof"] = 1,
			["lfw"] = 1,
			["lfm"] = 1,
			["lfg"] = 1,
			["wtb"] = 1,
			["wts"] = 1,
			["lfguild"] = 1,
			["guildlfm"] = 1
		},
		["class"] = {},
		["raid"] = {},
		["role"] = {},
		["prof"] = {}
	}
  end
  for match, strength in pairs(matches) do
      debug("Match: "..match.." x"..strength)
      if strength == 'e' then
          entry = exact[match]
          for classtype, classes in pairs(entry) do
              for class, score in pairs(classes) do
                  result[classtype][class] = (result[classtype][class] or 0) + score
              end
          end
          strength = 1
      end
      entry = fuzzy[match] or {}
      for classtype, classes in pairs(entry) do
          for class, score in pairs(classes) do
              result[classtype][class] = (result[classtype][class] or 0) + score * strength
          end
      end
  end
  for classtype, classes in pairs(result) do
      highestScore = 0.5
      for class, score in pairs(classes) do
        if score > highestScore then
          highestScore = score
        end
      end
      for class, score in pairs(classes) do
        result[classtype][class] = 1 - score/highestScore
      end
  end
  if logFiltering then
	LFMonitorLog[message] = result
  end
  return result
end

function LFMonitor:cachingClassifyMessage(message)
  return cacheLookup(LFMonitorCache, message, classifyMessage)
end

local function getClass(name, guid)
  if not guid then return "?" end
  return cacheLookup(LFMonitorClassCacheName, name, function()
    return cacheLookup(LFMonitorClassCacheGUID, guid, function(guid)
	  local _,class = GetPlayerInfoByGUID(guid) or "?"
	  return class
	end)
  end)
end

local function isInDesirableClass(result, desired, sensitivity)
  local anyClass = false
  for class, matches in pairs(result) do
    if matches <= sensitivity then
      if desired[class] then
		return true, true
	  else
	    anyClass = true
	  end
	end
  end
  return false, anyClass
end

local function isDesiredProfession(type, result, sensitivity)
	local profs = LFMonitorDB[type].professions
	if not profs then return true end
	if isInDesirableClass(result["prof"], profs, sensitivity) then
		return true
	else
		return profs.misc and not isInAnyClass(result["prof"], sensitivity)
	end
end

local function isDesiredRaid(type, result, sensitivity)
  local raids = LFMonitorDB[type].raids
  if not raids then
	debug(type.." messages are not filtered by raid.")
    return true
  elseif LFMonitorDB[type].overrideraid then
    debug(type.." messages have raid override enabled.")
	return true
  elseif isInDesirableClass(result["raid"], raids, sensitivity) then
    debug("Raid matched.")
	return true
  else
    debug("Raid did not match.")
	return false
  end
end

local canMatchOnSenderClass = {
	["lfg"] = true,
	["lfguild"] = true
}

local function isDesiredClassRole(type, result, sensitivity, name, guid)
  local classes = LFMonitorDB[type].classes
  local roles = LFMonitorDB[type].roles
  if not classes or not roles then
	debug(type.." messages are not filtered by class/role.")
	return true
  end
  local classMatch, anyClass = isInDesirableClass(result["class"],classes, sensitivity)
  local roleMatch, anyRole = isInDesirableClass(result["role"],roles, sensitivity)
  if classMatch then
	debug("Class matched.")
	return true
  elseif roleMatch then
	debug("Role matched.")
	return true
  elseif (not anyClass) and (not anyRole) and canMatchOnSenderClass[type] and classes[getClass(name, guid)] then
	debug("Sender's class matched.")
	return true
  else
	debug("Class and role did not match.")
  end
end

local function filter(result, sensitivity, name, guid)
  local type, score
  for type, score in pairs(result["type"]) do
	if LFMonitorDB.monitoring[type] and
	score <= sensitivity and
	isDesiredClassRole	(type, result, sensitivity, name, guid) and
	isDesiredRaid		(type, result, sensitivity) and
	isDesiredProfession (type, result, sensitivity) then
		return true, string_upper(type)
	end
  end
  return false
end

-- ***************************
-- * Miscellaneous functions *
-- ***************************
local function sendWhisper(priority, prefix, msg, type, lang, dest)

	local ch, msgchunk, segment, m
	local space = 0
	local msgs = {}

	msgchunk = msg

	if (string_len(msg) > 255) then

		while (string_len(msgchunk) > 255) do

			segment = string_sub(msgchunk, 1, 255)

			for ch = 255, 1, -1 do

				if (string_sub(segment, ch, ch) == " ") then

					space = ch
					break

				end

			end

			if (space == 0) then

				space = 255

			end

			table.insert(msgs, string_sub(segment, 1, space - 1))
			msgchunk = string_sub(msgchunk, space + 1)

		end

	end

	table.insert(msgs, msgchunk)

	for _, m in ipairs(msgs) do

		ChatThrottleLib:SendChatMessage(priority, prefix, m, type, lang, dest)

	end

end

local function resetEvent()

	if (LFMMAIN:GetScript("OnUpdate") == nil) then

		LFMMAIN:SetScript("OnUpdate", function(self, elapsed) LFMonitor:AlertOnUpdate(self, elapsed) end)

	end

end

function LFMonitor:PlayAlert(id)

	local sound = LFMonitor.sounds[id]

	if (LFMonitorDB.options.soundon) then

		if (sound.type == "game") then

			PlaySound(sound.file)

		else

			PlaySoundFile("Interface\\AddOns\\LFMonitor\\Sounds\\" .. sound.file)

		end

	end

end

local function GetAutoReply()

	local reply

	if (matchedvalue) then

		reply = LFMonitorDB.responses[matchedvalue]

	end

	return reply

end

function LFMonitor:ChatCommand(input)

	local command = string_lower(input or "")

	if (command == "show") then

		LFMonitorDB.options.disabled = 0
		SetDisable(false)

	elseif (command == "hide") then

		LFMonitorDB.options.disabled = 1
		SetDisable(true)

	elseif (command == "history") then

		LFMonitor:showHistoryTable('all')

	else

		InterfaceOptionsFrame_OpenToCategory(_G.LFMonitorOptionsMain)

	end

end

function LFMonitor:GetLocalTime(time)

	local format = LFMonitor.timestamps[LFMonitorDB.options.timestamp].format
	local localtime = date(format, time)

	return localtime

end

local function IsInstance()

	local inInstance, instanceType = IsInInstance()
	local ininstance = false

	if (inInstance ~= nil) then

		if (instanceType ~= "none") then

  			ininstance = true

		end

	end

  	return ininstance

end

local function alertHide()

	alertframe:Hide()

end

local function respond(self, event, ...)

	if (events[event]) then

		events[event](event, ...)

	end

end

function LFMonitor:lfmframeOnUpdate(self, elapsed)

	local flash = LFMEndFlash
	local flashtimer = LFMonitor.frame.flashtimer + elapsed

	if (alertframe:AtBottom()) then

		if (flash:IsShown()) then

			flash:Hide()

		end

		LFMonitor.frame:SetScript("OnUpdate", nil)

	elseif (flashtimer < CHAT_BUTTON_FLASH_TIME ) then

		LFMonitor.frame.flashtimer = flashtimer

	else

		LFMonitor.frame.flashtimer = 0

		if (flash:IsShown()) then

			flash:Hide()

		else

			flash:Show()

		end

	end

end

function LFMonitor:GetChannelNumber(channel)

	local channels = {GetChannelList()}
	local channelnumber = -1

	for num = 1, #channels, 2 do

		if (channels[num + 1] == channel) then

			channelnumber = num

		end

	end

	return channelnumber

end

local function eventframeInit(init)

	if (LFMonitor.testmode == true) then

		eventframe:RegisterEvent("CHAT_MSG_WHISPER_INFORM")

	else

		eventframe:RegisterEvent("CHAT_MSG_CHANNEL")
		eventframe:RegisterEvent("CHAT_MSG_SAY")
		eventframe:RegisterEvent("CHAT_MSG_YELL")

	end

	if (not inactive) then

		eventframe:RegisterEvent("PLAYER_UPDATE_RESTING")
		eventframe:RegisterEvent("PLAYER_ENTERING_WORLD")
		eventframe:RegisterEvent("PLAYER_REGEN_DISABLED")
		eventframe:RegisterEvent("PLAYER_REGEN_ENABLED")
		eventframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		eventframe:RegisterEvent("ZONE_CHANGED")
		eventframe:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE")

	end

	inactive = false
	eventframe:SetScript("OnEvent", respond)

	if (init) then

		tradechannel = LFMonitor:GetChannelNumber("Trade")
		LFMonitor:DisableCheck()

	end

	alertframe:Clear()

end

local function SetDisable(disable)

	if (disable == true) then

		if (alertframe:IsVisible()) then

			LFMonitor:OnDisable()
			inactive = true

		end

	else

		if (not alertframe:IsVisible()) then

			UIFrameFadeIn(alertframe, 1)
			resetEvent()
			eventframeInit()
			inactive = false

		end

	end

end

function LFMonitor:DisableCheck()

	local disable = false

	tradechannel = LFMonitor:GetChannelNumber("Trade")

	if (LFMonitorDB.options.hinst) then

		if (IsInstance()) then

			disable = true

		end

	end

	if (LFMonitorDB.options.rested) then

		if (not IsResting()) then

			disable = true

		end

	end

	if (LFMonitorDB.options.trade) then

		if (tradechannel == -1) then

			disable = true

		end

	end

	SetDisable(disable)

end

function LFMonitor:IsInBounds()

	local scale = UIParent:GetEffectiveScale()
	local x, y = GetCursorPosition()
	local xmin = LFMonitorDB.alert.position.x
	local xmax = xmin + LFMonitorDB.alert.position.width
	local ymax = LFMonitorDB.alert.position.y
	local ymin = ymax - LFMonitorDB.alert.position.height
	local inbounds = nil

	x = x / scale
	y = y / scale

	if ((x >= xmin) and (x <= xmax) and (y >= ymin) and (y <= ymax)) then

		inbounds = true

	end

	return inbounds

end

-- *************************
-- * Alert Frame Functions *
-- *************************

function LFMonitor:AlertShowButtons()

	UIFrameFadeIn(ScrollAlertFrameUpBtn, 0.5, 0, 1)
	UIFrameFadeIn(ScrollAlertFrameDownBtn, 0.5, 0, 1)
	UIFrameFadeIn(ScrollAlertFrameEndBtn, 0.5, 0, 1)

end

function LFMonitor:AlertHideButtons()

	ScrollAlertFrameUpBtn:Hide()
	ScrollAlertFrameDownBtn:Hide()
	ScrollAlertFrameEndBtn:Hide()

end

local function checkHistory(msg, sender, channel, result)

--ignore duplicate messages sent within 20 seconds of each other
--to try and cut down on channel spam

	local i, v
	local valid = 1

	if (#LFMonitor.history > 0) then

		for i,v in pairs(LFMonitor.history) do

			if ((v.msender == sender) and (v.mmsg == msg)) then
				if (time() - v.mtime < 20) then
					-- duplicate message; update history entry
					v.count = v.count + 1
					v.mtime = time()
					v.mchannel = channel or "?"
					LFMonitor:processMessageForHistory(i,v,result)
					valid = nil
					break

				end

			end

		end

	end

	if (valid) then

		if (LFMonitor.hindex == LFMonitor.historyMax) then

			LFMonitor.hindex = 1

		end
		v = {msender = sender, mmsg = msg, mtime = time(), count = 1, mchannel = channel or "?"}
		LFMonitor.history[LFMonitor.hindex] = v
		LFMonitor:processMessageForHistory(LFMonitor.hindex,v,result)
		LFMonitor.hindex = LFMonitor.hindex + 1

	end

	return valid

end

local function addAlert(msg, sender, guid, channel, result, class)
	if not alertframe then
		return
	end
	local hlink
	local plink = "[" .. sender .. "]:|h|r "
	local tlink = "|c" .. LFMonitorDB.alert.font.timestamp .. LFMonitor:GetLocalTime() .. "|r"
	local mcol = "|c" .. LFMonitorDB.alert.font.text
	local pcol

	if guid == -99999 then

		return

	end

	if (LFMonitorDB.options.useclasscolours) then

		pcol = LFMonitor.ClassColorTable[class]

	else

		pcol = LFMonitorDB.alert.font.player

	end

	hlink = "|c" .. pcol .. "|Hplayer:" .. sender .. ":LFMONITOR:" .. cfflag .. "|h"

	if (checkHistory(msg, sender, channel, result)) then

		LFMonitor:PlayAlert(LFMonitorDB.options.sound)

		if (alertframe:GetAlpha() ~= 1) then

			LFMonitor:AlertFadeIn(0.1)

		end

		alertframe.TimeSinceLastUpdate = 0
		alertframe:AddMessage(tlink .. hlink .. plink .. mcol .. LFMonitor:FormatMessage(msg) .. "|r", 1, 1, 1, 1, 60.0)

	end

end

function LFMonitor:SetLocked(locked)

	alertframe.isLocked = locked
	LFMonitorDB.options.locked = locked

end

function LFMonitor:AlertFadeIn(ftime)

	if (not mouse) then

		if (alertframe:GetAlpha() ~= 1) then

			UIFrameFadeIn(alertframe, ftime, 0.3, 1)
			resetEvent()

		end

	end

end

function LFMonitor:AlertFadeOut(ftime)

	if (alertframe:GetAlpha() == 1) then

		UIFrameFadeOut(alertframe, ftime, 1, 0.3)

	end

end

function LFMonitor:SetMouse(bValue)

	mouse = bValue

end

function LFMonitor:SetAlertFont()

	local r, g, b, a = LFMonitor:HexToRGB(LFMonitorDB.alert.font.text)
	local fontfile = LFMonitor.fonts[LFMonitorDB.alert.font.index].file

	alertframe:SetFont(fontfile, LFMonitorDB.alert.font.height)

end

function LFMonitor:SetAlertBackdropColour()

	local r, g, b, a = LFMonitor:HexToRGB(LFMonitorDB.alert.backdrop.background)

	alertframe:SetBackdropColor(r, g, b, a)

end

function LFMonitor:SetAlertBorderColour()

	local r, g, b, a = LFMonitor:HexToRGB(LFMonitorDB.alert.backdrop.border)

	alertframe:SetBackdropBorderColor(r, g, b, a)

end

function LFMonitor:SetAlertSkin()
	if alertframe then
		LFMonitor:SetAlertFont()
		LFMonitor:SetAlertBackdropColour()
		LFMonitor:SetAlertBorderColour()
	end
end
function LFMonitor:ClearAlerts()
	if alertframe then
		alertframe:Clear()
	end
end

-- *******************
-- * Event Functions *
-- *******************

function LFMonitor:OnInitialise()
	local x, y
	local slashcmd, slashidx = "LFMONITOR_CMD", 1

	LFMDBSVARS = LFMonitorDB

	if (IsAddOnLoaded("TradeForwarder")) then

		LFMonitor.tfw = true

	else

		LFMonitor.tfw = nil

	end

	LFMonitor:CheckSettingsVersion()
end

function LFMonitor:OnDisable()

	local r, g, b, a = LFMMAIN:GetBackdropColor()

	if (LFMonitor.testmode == true) then

		eventframe:UnregisterEvent("CHAT_MSG_WHISPER_INFORM")

	else

		eventframe:UnregisterEvent("CHAT_MSG_CHANNEL")
		eventframe:UnregisterEvent("CHAT_MSG_SAY")
		eventframe:UnregisterEvent("CHAT_MSG_YELL")

	end

	LFMonitor.frame:SetScript("OnUpdate", nil)
	LFMMAIN:SetScript("OnUpdate", nil)

	UIFrameFadeOut(alertframe, 1, a, 0)
	alertframe.fadeInfo.finishedFunc = alertHide
	inactive = true

end

function events.PLAYER_REGEN_DISABLED()

	--player entering combat
	if (LFMonitorDB.options.combat) then

		if (alertframe:IsVisible()) then

			dis = true
			combat = true
			UIFrameFadeOut(alertframe, 1)
			alertframe.fadeInfo.finishedFunc = alertHide

		end

	end

end

function events.PLAYER_REGEN_ENABLED()

	--player leaving combat
	if (combat) then

		UIFrameFadeIn(alertframe, 1)
		resetEvent()
		combat = false

	end

end

function events.PLAYER_UPDATE_RESTING(event, ...)

	tradechannel = LFMonitor:GetChannelNumber("Trade")
	LFMonitor:DisableCheck()

end

function events.ZONE_CHANGED_NEW_AREA(event, ...)

	tradechannel = LFMonitor:GetChannelNumber("Trade")
	LFMonitor:DisableCheck()

end

function events.ZONE_CHANGED(event, ...)

	tradechannel = LFMonitor:GetChannelNumber("Trade")
	LFMonitor:DisableCheck()

end

function events.PLAYER_ENTERING_WORLD(event, ...)

    ENTERING = true
    LFMonitor:ScheduleTimer(JoinChannelIfNeeded, 15)
	tradechannel = LFMonitor:GetChannelNumber("Trade")
	LFMonitor:DisableCheck()

--	if (LFMonitorDB.raids.eoe) then

--		LFMonitorDB.raids = {}

--	end

end

function LFMonitor:AlertOnUpdate(self, elapsed)

	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed

	if (self.TimeSinceLastUpdate < LFMonitor.LFM_Update_Int) then

		return

	end

	if (alertframe:IsVisible()) then

		if (alertframe:GetAlpha() == 1) then

			if (mouse == false) then

				self.TimeSinceLastUpdate = 0
				LFMonitor:AlertHideButtons()
		    	LFMonitor:AlertFadeOut(2)
		    	LFMonitor:AlertFadeOut(2)
				LFMMAIN:SetScript("OnUpdate", nil)
				mouse = false

		  	end

		end

	end

end

function LFMonitor:OnHyperlinkShow(self, link, text, button)

	SetItemRef(link, text, button)

end

local function tableEmpty(table)

	for _, _ in pairs(table) do
		return false
	end
	return true

end

local function classifyAddonMessage(message)
  local result = {
		["type"] = {
			["lfprof"] = 1,
			["lfw"] = 1,
			["lfm"] = 1,
			["lfg"] = 1,
			["wtb"] = 1,
			["wts"] = 1,
			["lfguild"] = 1,
			["guildlfm"] = 1
		},
		["class"] = {},
		["raid"] = {},
		["role"] = {},
		["prof"] = {}
  }
  local tag, userMessage = string_split("#", message, 2)
  local tagentries = {string_split(" ",tag)}
  local type = tagentries[1]
  local otherTags
  if type == "LFP" then
    result["type"]["lfprof"] = 0
  elseif type == "LFW" then
    result["type"]["lfw"] = 0
  elseif type == "LFM" then
    result["type"]["lfm"] = 0
  elseif type == "LFG" then
    result["type"]["lfg"] = 0
  elseif type == "WTB" then
    result["type"]["wtb"] = 0
  elseif type == "WTS" then
    result["type"]["wts"] = 0
  elseif type == "LFGD" then
    result["type"]["lfguild"] = 0
  elseif type == "GLFM" then
    result["type"]["guildlfm"] = 0
  else
--    print("Invalid type "..type)
    return result,""
  end
  local humanReadable = LFMonitor.ABBRS["type"][type] or type
  local i, tagentry, key, value
  for i=2,#tagentries do
    key,tagentry = string_split("=", tagentries[i], 2)
    if key and result[key] and tagentry then
      for _, value in pairs{string_split(",",tagentry)} do
        result[key][value] = 0
      end
      humanReadable = humanReadable .. " (" .. LFMonitor.classifierResultToText(result,key) .. ")"
    end
  end
  if userMessage then
    humanReadable = humanReadable .. ": " .. userMessage
  end
  return result, humanReadable
end


local function ChatParser(frame, event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, _, counter, guid, ...)
	local sensitivity = LFMonitorDB.options.sensitivity
	local message = nil
	local pattern, lmsg = nil, nil
	local omsg, classtxt = chatmessage, nil
	local matched, lfmgen = false, true
	local channelmatch = false
	local channel = ""
	local tmp = {}
	local i, channels = {}
	local tfwidx, tfwname, tfwmsg, tfwcolour
	local lfmsender, original
    local addonChannel = false
	lfmsender = sender
	if LFMonitorDB.options.ignoreself and (lfmsender == me) then
	  return false
	end
--    if channelNumber == addonChNumber then
--    end
	if (LFMonitorDB.channels.general) then

		if event == "CHAT_MSG_SAY" then
			channel = "S"
			channelmatch = true
		elseif event == "CHAT_MSG_YELL" then
			channel = "Y"
			channelmatch = true
		elseif zoneid == 1 then
			channel = "1"
			channelmatch = true
		end

	end

	if (LFMonitorDB.channels.trade) then
		if (zoneid == 2) then
			channel = "2"
			channelmatch = true
		end

	end

	if (LFMonitorDB.channels.guild) then
		if (event == "CHAT_MSG_GUILD") then
			channel = "G"
			channelmatch = true
		end
	end

	if (LFMonitorDB.channels.lfg) then
		if (zoneid == 26) then
			channelmatch = true
			channel = "4"
		end
	end

	if (channelmatch == false) then

		channels = {GetChannelList()}
		for i = 1, #channels, 2 do
			if (channels[i] > 4) and channelnumber == channels[i] then
--				print("channel",channels[i],channels[i+1])
--				print(channels[i+1] == addonChannelName)
				if (channels[i+1] == addonChannelName) then
--				  print("Addon channel message")
                  addonChannel = true
                  channelmatch = true
                  channel = "L"
                  break
                elseif (LFMonitorDB.channels["cc" .. channels[i + 1]]) then
                  channelmatch = true
                  channel = ""..channels[i]
                  break

				end
			end

		end

	end

	if (LFMMAIN:IsVisible()) then

		if ((channelmatch == true) or (LFMonitor.testmode == true)) then

              local result
              if addonChannel then
--			    print("Addon channel message being eval'd")
                result, omsg = classifyAddonMessage(omsg)
              else
                if LFMonitor.tfw then

                    tfwidx, tfwname, tfwmsg, tfwcolor = strmatch(omsg, LFMonitor.TFW_PATTERN)

                    if tfwmsg then
                        omsg = tfwmsg
                        lfmsender = tfwname
                    end

                end
                result = LFMonitor:cachingClassifyMessage(omsg)
              end
			  if result["error"] then
				  debug(result["error"])
				  matched = true
              else
				  matched, cfflag = filter(result, sensitivity, sender, guid)
              end

              if (not matched) then

                  if ((LFMonitorDB.options.basic or "") ~= "") then

                      cfflag = "CUSTOM"
                      tmp = {}

                      if (string_find(LFMonitorDB.options.basicesc, " ")) then

                          tmp = {strsplit(" ", string_lower(LFMonitorDB.options.basicesc))}

                      else

                          table.insert(tmp, string_lower(LFMonitorDB.options.basicesc))

                      end

                      matched = doSearch(LFMonitor.nop, formatspecial(omsg), tmp)

                  end

              end

              if (not matched) then

                  if ((LFMonitorDB.options.adv or "") ~= "") then

                      cfflag = "CUSTOM"
                      tmp = {}
                      table.insert(tmp, LFMonitorDB.options.adv)
                      matched = doSearch(LFMonitor.nop, formatspecial(omsg), tmp)

                  end

              end
              if matched then
                  addAlert(omsg, lfmsender, guid, channel, result, class)
              else
                  checkHistory(omsg, lfmsender, channel, result)
              end
		end

	end
	return addonChannel -- don't display raw messages from the add-on channel
end
if IsAddOnLoaded("SpamBayes") and SpamBayes.addPostHook then -- see http://wow.curseforge.com/addons/spambayes/tickets/10-fix-attached-post-hooks-so-other-add-ons-can-ignore
	SpamBayes:addPostHook(ChatParser)
else
-- NB: ChatParser is idempotent over up to 20 seconds thanks to the throttling and cache, so using it as a filter should be safe.
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL",ChatParser)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM",ChatParser)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL",ChatParser)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY",ChatParser)
end

-- function events.CHAT_MSG_CHANNEL(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)
--
--	ChatParser(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)
--
--end

--function events.CHAT_MSG_WHISPER_INFORM(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)
--
--	ChatParser(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)
--
--end

--function events.CHAT_MSG_YELL(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)
--
--	ChatParser(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)
--
--end

--function events.CHAT_MSG_SAY(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)
--
--	ChatParser(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)
--
--end

function events.CHAT_MSG_CHANNEL_NOTICE(event, chatmessage, sender, language, channelstring, target, flags, zoneid, channelnumber, channelname, counter, ...)

	tradechannel = LFMonitor:GetChannelNumber("Trade")
	LFMonitor:DisableCheck()

end

function LFMonitor:OnEnable()
	LFMonitor:CreateOptions()
	if (LFMonitorDB.alert.position.x == -1) then

		x = (UIParent:GetWidth() - LFMonitorDB.alert.position.width) / 2
		y = (UIParent:GetHeight() - LFMonitorDB.alert.position.height) / 2
		LFMonitorDB.alert.position.x = x
		LFMonitorDB.alert.position.y = y

	end

	alertframe = LFMonitor:CreateAlertFrame()

	eventframe = CreateFrame("Frame", "LFMonitorEventFrame")
	eventframeInit(true)
	LFMonitor:BuildTables()
	tradechannel = LFMonitor:GetChannelNumber("Trade")
	LFMonitor:DisableCheck()

	if (IsAddOnLoaded("TradeForwarder")) then

		LFMonitor.tfw = 1

	else

		LFMonitor.tfw = nil

	end

end

-- ******************
-- * Dropdown Menus *
-- ******************

local function LFMonitor_DDMenuItem_OnClick(self, button, down)

	local opt = self.value
	local reply, rtmp = nil, nil
	local cl = nil

	PlaySound("igMainMenuOption")

	if (opt == 1) then

		--autoreply
		reply = GetAutoReply()

		if (reply == nil or reply == "") then

			--nothing to autoreply with
			StaticPopup_Show("LFMONITOR_NOAUTOREPLY")

		else

			rtmp = string_sub(reply, 1, 255)

			sendWhisper("NORMAL", "LFMONITOR", reply, "WHISPER", nil, pname)

		end

	elseif(opt == 2) then

		--whisper
		ChatFrame1EditBox:SetText(_G.SLASH_WHISPER1 .. " " .. pname .. " ")

	elseif(opt == 3) then

		--ignore
		AddIgnore(pname)

	elseif(opt == 4) then

		--cancel
		--do nothing

	end

end

local function LFMonitor_DD_Initialise()

	local info

	info = {}
	info.text = pname
	info.value = 0
	info.owner = ddmenu
	info.isTitle = true
	info.func = nil
	info.notCheckable = 1
	UIDropDownMenu_AddButton(info)

	info = {}
	info.text = LFMonitor.AUTOREPLY
	info.value = 1
	info.owner = ddmenu
	info.notCheckable = 1
	info.isTitle = nil

	if (pflag == "LFG" or pflag == "WTB") then

		info.disabled = true

	else

		info.disabled = nil

	end

	info.tooltipTitle = LFMonitor.AUTOREPLY
	info.tooltipText = string_format(LFMonitor.SEND_AUTO, pname)
	info.func = LFMonitor_DDMenuItem_OnClick
	UIDropDownMenu_AddButton(info, 1)

	info = {}
	info.text = _G.WHISPER
	info.value = 2
	info.owner = ddmenu
	info.isTitle = nil
	info.disabled = nil
	info.notCheckable = 1
	info.tooltipTitle = _G.WHISPER
	info.tooltipText = string_format(LFMonitor.WHISPER, pname)
	info.func = LFMonitor_DDMenuItem_OnClick
	UIDropDownMenu_AddButton(info, 1)

	info = {}
	info.text = _G.IGNORE
	info.value = 3
	info.owner = ddmenu
	info.isTitle = nil
	info.disabled = nil
	info.tooltipTitle = _G.IGNORE
	info.notCheckable = 1
	info.tooltipText = string_format(LFMonitor.IGNORE_LIST, pname)
	info.func = LFMonitor_DDMenuItem_OnClick
	UIDropDownMenu_AddButton(info, 1)

	info = {}
	info.text = _G.CANCEL
	info.value = 4
	info.owner = ddmenu
	info.isTitle = nil
	info.disabled = nil
	info.notCheckable = 1
	info.tooltipTitle = _G.CANCEL
	info.tooltipText = LFMonitor.CLOSE_MENU
	info.func = LFMonitor_DDMenuItem_OnClick
	UIDropDownMenu_AddButton(info, 1)

end

local function LFMonitor_ShowDDMenu(link)

	local htype, hname, hmod, flag = strsplit(":", link)

	pname = hname
	pflag = flag

	ddmenu = _G.LFMonitorDDMenu
	ddmenu.initialize = LFMonitor_DD_Initialise
	ddmenu.displayMode = "MENU"
	ddmenu.name = "LFMonitor"
	PlaySound("igMainMenuOpen")
	ToggleDropDownMenu(1, nil, ddmenu, "cursor")

end

-- *********
-- * Hooks *
-- *********

--Hook SetItemRef so LFMonitor can handle its own custom links
local ORIG_SetItemRef = _G.SetItemRef

local function LFMonitor_SetItemRef (link, text, button, ...)

	local htype, hname, hmod, flag = strsplit(":", link)
	local runorig = nil

	if (IsModifiedClick("CHATLINK")) then

		runorig = true

	elseif (button == "RightButton") then

		if (hmod == "LFMONITOR") then

			LFMonitor_ShowDDMenu(link)

		else

			runorig = true

		end

	else

		runorig = true

	end

	if (runorig) then

		ORIG_SetItemRef(link, text, button, ...)

	end

end

_G.SetItemRef = LFMonitor_SetItemRef

--Hook ChatEdit_GetActiveWindow so LFMonitor can capture links in the options frame
local orig_ChatEdit_GetActiveWindow = ChatEdit_GetActiveWindow

function ChatEdit_GetActiveWindow()

    return LFMonitor.EditFocus or orig_ChatEdit_GetActiveWindow()

end

local function benchmark(operation, message, benchmarkCount)
	collectgarbage()
	debugprofilestart()
	for i=1,benchmarkCount do
		operation()
	end
	local run = debugprofilestop()
	local memory = collectgarbage("count")
	debugprofilestart()
	collectgarbage()
	local gc = debugprofilestop()
	local memory_nogarbage = collectgarbage("count")
	print(string_format("%s: %d ms (%d run, %d gc), %d-%d kB",message,gc+run,run,gc,memory_nogarbage,memory))
end

function permute(word)
	local numChanges = math_random(math_min(string_len(word)/2,3))
	local n, pos, op
	for n=1,numChanges do
		pos = math_random(string_len(word))
		op = math_random(3)
		if op == 1 then -- deletion
			word = string_sub(word,1,pos-1)..string_sub(word,pos+1)
		elseif op == 2 then -- substitution
			word = string_sub(word,1,pos-1)..strchar(math_random(96,122))..string_sub(word,pos+1)
		else -- insertion
			word = string_sub(word,1,pos-1)..strchar(math_random(96,122))..string_sub(word,pos)
		end
	end
	return word
end

function randomWord(dictionary, chanceDictionary, chanceLink, chanceSpecial, avgLength)
	local roll = math_random()
	if roll < chanceLink then
		return "|c" .. randomWord(dictionary,0,0,0,8) .. "|H" .. randomWord(dictionary,0,0,0,12) .. "|h[" .. randomWord(dictionary, chanceDictionary, 0, 0, avgLength) .. "]|h|r"
	elseif roll < chanceLink + chanceSpecial then
		return "{" .. randomWord(dictionary, chanceDictionary, 0, 0, avgLength) .. "}"
	elseif roll < chanceLink + chanceSpecial + chanceDictionary then
		return permute(dictionary[math_random(#dictionary)])
	else
		local word = ""
		local chanceStop = 1/(avgLength - 1)
		repeat
			word = word .. strchar(math_random(96,122))
		until math_random() < chanceStop
		return word
	end
end

function randomDict() -- list of all words from fuzzy for random message generation
	local dict = {}
	for k, _ in pairs(fuzzy) do
		if not exact[k] then
			tinsert(dict, k)
		end
	end
	return dict
end

function LFMonitor:benchmarkWordMatch(avgLength, benchmarkCount)
	local strings = {}
	local i
	for i=1,benchmarkCount do
		strings[i] = randomWord(nil,0,0,0,avgLength)
	end
	i=1
	benchmark( function()
			fuzzyWordMatch(strings[i])
			i=i+1
		end, "fuzzyWordMatch", benchmarkCount)
end

function LFMonitor:benchmarkWordSimilarity(avgLength, benchmarkCount)
	local strings = {}
	local i
	for i=1,benchmarkCount do
		strings[i] = randomWord(nil,0,0,0,avgLength)
	end
	i=1
	benchmark( function()
			wordSimilarity(strings[i], strings[math_random(benchmarkCount)])
			i=i+1
		end, "fuzzyWordMatch", benchmarkCount)
end

function LFMonitor:benchmarkFiltering(wordCacheSize, messageCacheSize, benchmarkCount)
	local dict = randomDict()
	local avgWordLength = 5
	local avgMessageLength = 6
	local chanceStop = 1/(avgMessageLength - 1)
	local chanceLink = .1 / avgMessageLength -- 1 link per 10 messages
	local chanceSpecial = .02 / avgMessageLength -- 1 special per 50 messages
	local dictMessages = {}
	local nonDictMessages = {}
	local n
	for n=1,benchmarkCount do
		dictMessages[n] = ""
		nonDictMessages[n] = ""
		repeat
			dictMessages[n] = dictMessages[n] .. randomWord(dict, 1, chanceLink, chanceSpecial, avgWordLength) .. " "
			nonDictMessages[n] = nonDictMessages[n] .. randomWord(nil, 0, chanceLink, chanceSpecial, avgWordLength) .. " "
		until math_random() < chanceStop
	end
	LFMonitorCache = {score = {}, count=0, max = messageCacheSize}
	LFMonitorWordCache = {score = {}, count=0, max = wordCacheSize}
	local i=1
	benchmark( function ()
		LFMonitor:cachingClassifyMessage(nonDictMessages[i])
		i=i+1
		end, "Messages not generated with dictionary", benchmarkCount)
	i=1
	benchmark( function ()
		LFMonitor:cachingClassifyMessage(dictMessages[i])
		i=i+1
		end, "Messages generated with dictionary", benchmarkCount)
	benchmark( function ()
		LFMonitor:cachingClassifyMessage(dictMessages[math_random(benchmarkCount)])
		end, "Repeat messages", benchmarkCount)
--	LFMonitorCache = {score = {}, count = 0, max = messageCacheSize}
end

-- following method taken from TradeForwarder
function events.CHAT_MSG_CHANNEL_NOTICE(event,...)
  local message, sender, language, channelString, target, flags, _, channelNumber, channelName, _, counter = ...;
--  LFW_DEBUG("NOTICE^^"..message.." "..language.." '"..channelName.."'");
  if(channelName==addonChannelName) then
      if(message == "YOU_JOINED") then   --init when logon.
          addonChNumber = channelNumber;   --channelNumber is needed to SendChatMessage
--          chatInfo = ChatTypeInfo["CHANNEL"..tfwChNumber] or LFW_CHAT_INFO_DEFAULT
--          DisplayChannelOwner(TFW_CHANNEL_NAME);  --get owner
--          if(isInLFG) then SendCmd(LFW_CMD_JOIN); end
--          SendCmd(LFW_CMD_VERSION..TFW_VERSION);
          kicked = nil;
          ENTERING = nil;

      elseif(message == "YOU_LEFT" or message == "SUSPENDED") then
          isOwner = false;
--          table.wipe(sentCache); --left channel, so delete all unsent
--          tfwChNumber = nil;
--          chatInfo = LFW_CHAT_INFO_DEFAULT

      elseif(message == "BANNED") then
--          TFW_AddMessage(format(_G["CHAT_"..message.."_NOTICE"], channelName), nil, nil, nil, true)
          kicked = true
          LFMonitor:ScheduleTimer(JoinChannelIfNeeded, 60)

      end
 -- else
 --     if(frame.ENTERING ~= false and frame.ENTERING > LFW_CHANNEL_JOIN_DELAY) then
 --         frame.ENTERING = LFW_CHANNEL_JOIN_DELAY
 --     end
  end
end
SLASH_LFMONITOR_CMD1 = "/" .. LFMonitor.CHAT_COMMANDS[1]
SLASH_LFMONITOR_CMD2 = "/" .. LFMonitor.CHAT_COMMANDS[2]
SlashCmdList["LFMONITOR_CMD"] = function(input) LFMonitor:ChatCommand(input) end
