﻿if ((GetLocale() == "enUS") or (LFMonitor.TEXT == nil)) then

	local bz = LFMonitor.BZ
	local bb = LFMonitor.BB
	local bi = LFMonitor.BI
	local l = function(s)
		return string.gsub(string.lower(s),"'","")
	end

	LFMonitor.LOCALE_STRINGS = {
		-- GENERAL OPTIONS
		["Ignore my own messages"] = "Ignore my own messages",
		["Hide LFMonitor when:"] = "Hide LFMonitor when:",
		["Not in a city or inn"] = "Not in a city or inn",
		["Monitored channels"] = "Monitored channels",
		["Cache size"] = "Cache size",
		["Filter sensitivity"] = "Filter sensitivity",
		["In combat"] = "In combat",
		--sounds
		["Coins"] = "Coins",
		["Window tab"] = "Window tab",
		["Menu opening"] = "Menu opening",
		["Minimap opening"] = "Minimap opening",
		["Spellbook opening"] = "Spellbook opening",
		["Spellbook closing"] = "Spellbook closing",
		["Talents opening"] = "Talents opening",
		["Quest log opening"] = "Quest log opening",
		-- bi["Fishing"]
		["Discovery"] = "Discovery",
		["Applause"] = "Applause",
		["Beep"] = "Beep",
		["Click"] = "Click",
		["Dog barking"] = "Dog barking",
		["Mouse click"] = "Mouse click",
		["Stapler"] = "Stapler",
		-- FILTERING OPTIONS
		["Filtering"] = "Filtering",
		["Search for and display messages of this type"] = "Search for and display messages of this type",
		-- request types
		["Want to Buy"] = "Want to Buy",
		["Want to Sell"] = "Want to Sell",
		["Looking for Guild"] = "Looking for Guild",
		["Guild Recruitment"] = "Guild Recruitment",
		["Looking for Work"] = "Looking for Work",
		["Looking for Crafter/Service"] = "Looking for Crafter/Service",
		-- services
		["Other Services"] = "Other Services",
		["Mount Rides"] = "Mount Rides",
		["Mage Portals"] = "Mage Portals",
		-- classes
		["Classes"] = "Classes",
		-- roles
		["Roles"] = "Roles",
		["Tank / Flag Carrier"] = "Tank / Flag Carrier",
		["Crowd Control"] = "Crowd Control",
		-- instances
		["Instances"] = "Instances",
		["Dungeons"] = "Dungeons",
		["Raids"] = "Raids",
		["Don't filter by instance"] = "Don't filter by instance",
		-- ERROR MESSAGES
		["Your settings have been reset because they were incompatible with this version of LFMonitor."] =
		"Your settings have been reset because they were incompatible with this version of LFMonitor."
	}

-- Word matching pattern
    LFMonitor.WORD_PATTERN = "[%a%d][%a%d']*[%a%d]"
	-- to match this pattern, a word must:
		-- have at least 2 characters
		-- not include whitespace, or punctuation other than apostrophes
		-- not start or end with an apostrophe

-- Chat commands
	LFMonitor.CHAT_COMMANDS = {"lfmonitor", "lfmon"}

--fonts
	LFMonitor.FONT_FRIZ = "Friz Quadrata TT"
	LFMonitor.FONT_ARIALN = "Arial Narrow"
	LFMonitor.FONT_SKURRI = "Skurri"
	LFMonitor.FONT_MORPHEUS = "Morpheus"

--appearance options
	LFMonitor.APPEARANCE_OPTIONS = "Appearance options"
	LFMonitor.MESSAGE_TEXT = "Message text"
	LFMonitor.TEXT = "Text"
	LFMonitor.WINDOW = "Window"
	LFMonitor.FONT = "Font"

-- For history table

	local red   = "|cFFFF0000"
	local blue  = "|cFF9999FF"
	local green = "|cFF00FF00"
	local yellow= "|cFFFFFF33"
	local orange= "|cFFFF9900"
	local pink  = "|cFFFF00FF"
	local gray  = "|cFF999999"

	LFMonitor.HISTORY_COLUMN_HEADERS = {
		Count = "#",
		Channel = "C",
		Timestamp = "Time",
		Player = _G.PLAYER,
		Type = "Type",
		Raid = "Raid",
		Class = _G.CLASS,
		Role = _G.RAID_SORT_ROLE,
		Profession = "Prof",
		Message = LFMonitor.MESSAGE_TEXT,
	}
	LFMonitor.TABLE_UNKNOWN = gray.."--".."|r" -- indicates that no known categories apply to a message

	LFMonitor.SHOW_TYPES = "Show message types"

	LFMonitor.ABBRS = {
		["type"] = {
			["lfprof"]  = green .."LF".."|r",
			["lfw"]     = red   .."LFW".."|r",
			["lfm"]     = yellow.."LFM".."|r",
			["lfg"]     = blue  .."LFG".."|r",
			["wtb"]     = green .."WTB".."|r",
			["wts"]     = red   .."WTS".."|r",
			["lfguild"] = pink  .."LFGld".."|r",
			["guildlfm"]= orange.."GldLFM".."|r",
			["unknown"]	= "Other"
		},
		["role"] = {
			["tank"]   = green .."T".."|r",
			["healer"] = yellow.."H".."|r",
			["melee"]  = blue  .."M".."|r",
			["ranged"] = pink  .."R".."|r",
			["cc"] = "CC",
			["all"] = "A"
		},
		["prof"] = {
			["jc"] = "Jc",
			["enc"] = "Enc",
			["lw"] = "Lw",
			["ins"] = "In",
			["tlr"] = "Tl",
			["bs"] = "Bs",
			["alc"] = "Al",
			["eng"] = "Eng",
			["misc"] = "??",
			["pm"] = "Pm", --Potion Master
			["em"] = "Em", --Elixir Master
			["xm"] = "Xm", --Transmutation Master
			["co"] = "Co",
			["sm"] = "Sm", --Smelting
			["lp"] = "Lp", --Lockpicking
			["port"] = "Port",
			["hgwt"] = "HG", -- Have Group, Will Travel
			["fly"] = "Fly",

		},
		["raid"] ={
			["RBG"] = "RBG",
			["2s"]  = "2s",
			["3s"]  = "3s",
			["5s"]  = "5s",
			["FL"]  = "FL",
			["BH"]	= "BH",
			["BWD"] = "BWD",
			["BoT"] = "BoT",
			["TFW"] = "TFW",
			["EoE"] = "EoE",
			["ICC"] = "ICC",
			["Nax"] = "Nax",
			["Ony"] = "Ony",
			["OS"] = "OS",
			["RS"] = "RS",
			["ToC"] = "ToC",
			["Uld"] = "Uld",
			["VoA"] = "VoA",
			["Hyj"] = "Hyj",
			["BT"] = "BT",
			["GL"] = "GL",
			["Kra"] = "Kra",
			["Mag"] = "Mag",
			["SSC"] = "SSC",
			["SWP"] = "SWP",
			["TK"] = "TK",
			["ZA"] = "ZA",
			["BWL"] = "BWL",
			["MC"] = "MC",
			["AQ10"] = "AQ10",
			["AQ40"] = "AQ40",
			["ZG"] = "ZG",
			["UBRS"] = "UBRS"
		},
		["class"] = {
			["DEATHKNIGHT"] = "|cFFC41F3B".."Dk".."|r",
			["DRUID"] = "|cFFFF7D0A".."Dr".."|r",
			["HUNTER"] = "|cFFABD473".."Hu".."|r",
			["MAGE"] = "|cFF69CCF0".."Ma".."|r",
			["PALADIN"] = "|cFFF58CBA".."Pa".."|r",
			["PRIEST"] = "|cFFFFFFFF".."Pr".."|r",
			["ROGUE"] = "|cFFFFF569".."Ro".."|r",
			["SHAMAN"] = "|cFF0070DE".."Sh".."|r",
			["WARLOCK"] = "|cFF9482C9".."Wl".."|r",
			["WARRIOR"] = "|cFFC79C6E".."Wr".."|r",
		}
	}


	LFMonitor.CLASS_COLOUR_TEXT = _G.CLASS_COLORS

--responses options
	LFMonitor.RESPONSES = "Responses"
	LFMonitor.RESPONSES_TO_REQUESTS = "Responses to 'Looking For' requests"
	LFMonitor.SET_RESPONSES = "Set the responses to provide to requests"
	LFMonitor.WHISPER_ME = "Whisper me for prices"
	LFMonitor.LFG_RESPONSE = "Invite"

--general options

--custom search
	LFMonitor.CUSTOM_OPTIONS = "Custom monitoring"
	LFMonitor.CUSTOM_INST = "Enter a word or phrase you would like monitored"
	LFMonitor.CUSTOM_BASIC = "Basic search"
	LFMonitor.CUSTOM_ADV = "Advanced search"
	LFMonitor.CUSTOM_WARNING = "The box below will accept any lua pattern matching expression. This is for advanced users only. More information on lua patterns can be found at |cff00ff00http://www.wowwiki.com/Pattern_matching"
	LFMonitor.CUSTOM_CHANNELS = "Monitor Custom Channels"



--menu
-- in all the following section %s will be replaced with the player's name
	LFMonitor.AUTOREPLY = "Autoreply"
	LFMonitor.SEND_AUTO = "Send your autoresponse to %s"
	LFMonitor.IGNORE_LIST = "Add %s to your ignore list"
	LFMonitor.CLOSE_MENU = "Close this menu"
	LFMonitor.WHISPER = "Whisper %s"

--dialogues
	LFMonitor.CANNOT_SEND = "Cannot send an autoreponse - nothing to reply with!"
	LFMonitor.RESET_CONFIRM = "The will reset ALL LFMonitor's settings. Are you sure?"

	LFMonitor.words = {
	  exact = {
		["lf8m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["jw"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 0.5,
		  },
		},
		["dk"] = {
		  ["class"] = {
			["DEATHKNIGHT"] = 1,
		  },
		},
		["os"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["OS"] = 0.5,
		  },
		},
		["lw"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lw"] = 1,
		  },
		},
		["bg"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 0.5,
		  },
		},
		["rs"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RS"] = 1,
		  },
		},
		["cc"] = {
		  ["role"] = {
			["cc"] = 0.5,
		  },
		},
		["lfg"] = {
		  ["type"] = {
			["lfg"] = 1,
		  },
		},
		["mc"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		["lf1"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["mt"] = {
		  ["role"] = {
			["tank"] = 1,
		  },
		},
		["lf4"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["2s"] = {
		  ["type"] = {
["lfg"] = 1,
["lfm"] = 1,
},
["raid"] ={
			["2s"] = 1,
		  },
		},
		["3s"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["3s"] = 1,
		  },
		},
		["lf7m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["lf4m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["5s"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["5s"] = 1,
		  },
		},
		["wtb"] = {
		  ["type"] = {
			["lfprof"] = 0.25,
			["lfm"] = 0.25,
			["wtb"] = 1,
		  },
		},
		["wtt"] = {
		  ["type"] = {
			["wtb"] = 1,
			["wts"] = 1,
		  },
		},
		["lf5"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["bs"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["bs"] = 1,
		  },
		},
		["kz"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["lf2"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["lf5m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["tk"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		["lf6"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["lfm"] = {
		  ["type"] = {
			["lfm"] = 1,
			["guildlfm"] = 0.5,
		  },
		},
		["lk"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["lf3"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["lf2m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["ot"] = {
		  ["role"] = {
			["tank"] = 1,
		  },
		},
		["aq"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 0.5,
			["AQ40"] = 0.5,
		  },
		},
		["lf7"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["wts"] = {
		  ["type"] = {
			["wts"] = 1,
		  },
		},
		["bh20"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},
		["bh"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},

		["lf"] = {
		  ["type"] = {
			["lfprof"] = 0.25,
		  },
		},
		["fc"] = {
		  ["role"] = {
			["tank"] = 1,
		  },
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 0.5,
		  },
		},
		["lf6m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["zg"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["mage"] = {
		  ["class"] = {
			["MAGE"] = 1,
		  },
		},
		["ml"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Mag"] = 1,
		  },
		},
		["jc"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 1,
		  },
		},
		["za"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
		  },
		},
		["bt"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 0.75,
		  },
		},
		["lf8"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["lf9m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["lf9"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["lf3m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["only"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Ony"] = 0.5,
		  },
		},
		["fl"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
	  },
	  fuzzy = {
-- top 40 words in English (http://www.duboislc.org/EducationWatch/First100Words.html), minus 1 and 2 letter words
["the"]={},
["and"]={},
["you"]={},
["that"]={},
["was"]={},
["for"]={},
["are"]={},
["with"]={},
["his"]={},
["they"]={},
["this"]={},
["have"]={},
["from"]={},
["one"]={},
["had"]={},
["word"]={},
["but"]={},
["not"]={},
["what"]={},
["were"]={},
["when"]={},
["your"]={},
["can"]={},
["said"]={},
-- rest of the list
		["pay"] = {
		  ["type"] = {
		    ["wtb"] = 1,
		  },
		},
		["paying"] = {
		  ["type"] = {
		    ["wtb"] = 1,
		  },
		},
		["icecrown"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 0.5,
		  },
		},
		["razorgore"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		["sulfuron"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		[l(bb["Festergut"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		[l(bb["Alysrazor"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["azgalor"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Hyj"] = 1,
		  },
		},
		["restoration"] = {
		  ["class"] = {
			["DRUID"] = 0.5,
			["SHAMAN"] = 0.5,
		  },
		},
		[l(bb["Beth'tilac"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["rbg"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 1,
		  },
		},
		[l(bb["Occu'thar"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},
		["beth"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["occu"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},
		["bwl40"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		["rbgs"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 1,
		  },
		},
		["druid"] = {
		  ["class"] = {
			["DRUID"] = 1,
		  },
		},
		["geddon"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		["faerlina"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["bgs"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 0.5,
		  },
		},
		["want"] = {
		  ["type"] = {
			["wts"] = 0.5,
			["wtb"] = 0.5,
		  },
		},
		["ony25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Ony"] = 1,
		  },
		},
		["akama"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		["eoe"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["EoE"] = 1,
		  },
		},
		["icc10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["baradin"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},
		["kara"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["raid"] ={
		  ["type"] = {
			["lfg"] = 0.5,
		  },
		},
		["alg"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["bwd25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 1,
		  },
		},
		["rhyolith"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["toc"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 1,
		  },
		},
		["ruins"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 0.5,
		  },
		},
		["naxx10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["craft"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
		},
		["theralion"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		["sell"] = {
		  ["type"] = {
			["wts"] = 0.5,
		  },
		},
		["val"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		["resto"] = {
		  ["class"] = {
			["DRUID"] = 0.5,
			["SHAMAN"] = 0.5,
		  },
		},
		["inscriptor"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["ins"] = 1,
		  },
		},
		["gl25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["GL"] = 1,
		  },
		},
		["healers"] = {
		  ["role"] = {
			["healer"] = 1,
		  },
		},
		["togc"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 1,
		  },
		},
		[l(bb["Zul'jin"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
		  },
		},
		[l(bb["Shannox"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["tk25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		["heals"] = {
		  ["role"] = {
			["healer"] = 1,
		  },
		},
		["heal"] = {
		  ["role"] = {
			["healer"] = 1,
		  },
		},
		[l(bb["Atramedes"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 1,
		  },
		},
		[l(bz["Hyjal"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Hyj"] = 1,
		  },
		},
		["mandokir"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["curator"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["arg"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},
		["enc"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["enc"] = 1,
		  },
		},
		["jewelcrafter"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 1,
		  },
		},
		["gruul"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["GL"] = 1,
		  },
		},
		["uld25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["blackrock"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 0.75,
		  },
		},
		["tailor"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["tlr"] = 1,
		  },
		},
		["wts"] = {
		  ["type"] = {
			["wts"] = 1,
			["wtb"] = -1
		  },
		},
		["princes"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 0.5,
		  },
		},
		["rag"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 0.5,
			["FL"] = 0.75,
		  },
		},
		["mag"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Mag"] = 1,
		  },
		},
		[l(bb["Chromaggus"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		[l(bb["Kil'jaeden"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		["buy"] = {
		  ["type"] = {
			["wtb"] = 0.5,
		  },
		},
		[l(bb["Magmaw"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 1,
		  },
		},
		[l(bb["M'uru"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		["buying"] = {
		  ["type"] = {
			["wtb"] = 1,
		  },
		},
		["aq10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 1,
		  },
		},
		["tempest"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		["eoe25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["EoE"] = 1,
		  },
		},
		[l(bb["Al'ar"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		["selling"] = {
		  ["type"] = {
			["wts"] = 1,
		  },
		},
		["frost"] = {
		  ["class"] = {
			["MAGE"] = 0.5,
		  },
		},
		["malacrass"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
		  },
		},
		[l(bz["Ahn'Qiraj"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 0.5,
			["AQ40"] = 0.5,
		  },
		},
		["icc"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["rog"] = {
		  ["class"] = {
			["ROGUE"] = 1,
		  },
		},
		["paladin"] = {
		  ["class"] = {
			["PALADIN"] = 1,
		  },
		},
		["lfg"] = {
		  ["type"] = {
			["lfg"] = 0.75,
		  },
		},
		["dks"] = {
		  ["class"] = {
			["DEATHKNIGHT"] = 1,
		  },
		},
		["shad"] = {
		  ["class"] = {
			["PRIEST"] = 1,
		  },
		},
		["carrier"] = {
		  ["role"] = {
			["tank"] = 0.5,
		  },
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 0.5,
		  },
		},
		["deeps"] = {
		  ["role"] = {
			["ranged"] = 1,
			["melee"] = 1,
		  },
		},
		["ascendant"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		[l(bb["Baleroc"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["najentus"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		["saurfang"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["troll"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 0.5,
			["ZG"] = 0.5,
		  },
		},
		["naxx25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["gorefiend"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		["link"] = {
		  ["type"] = {
			["lfprof"] = 0.5,
		  },
		},
		["bastion"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		["gems"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 0.75,
		  },
		},
		["anetheron"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Hyj"] = 1,
		  },
		},
		[l(bb["Firemaw"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		["nef"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 0.75,
		  },
		},
		["warlock"] = {
		  ["class"] = {
			["WARLOCK"] = 1,
		  },
		},
		[l(bb["Sindragosa"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["madness"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["lock"] = {
		  ["class"] = {
			["WARLOCK"] = 0.75,
		  },
		},
		["majordomo"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 0.5,
			["FL"] = 0.75,
		  },
		},
		["ranged"] = {
		  ["role"] = {
			["ranged"] = 1,
		  },
		},
		["elemental"] = {
		  ["class"] = {
			["SHAMAN"] = 1,
		  },
		},
		["enhance"] = {
		  ["class"] = {
			["SHAMAN"] = 1,
		  },
		},
		["flamewreath"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		[l(bb["Garr"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		["skeram"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["bh25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},
		["jcer"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 1,
		  },
		},
		["enh"] = {
		  ["class"] = {
			["SHAMAN"] = 1,
		  },
		},
		["balance"] = {
		  ["class"] = {
			["DRUID"] = 1,
		  },
		},
		["aq20"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 1,
		  },
		},
		["bal"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 0.75,
		  },
		},
		["huhuran"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["throne"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TFW"] = 1,
		  },
		},
		["dpser"] = {
		  ["role"] = {
			["ranged"] = 0.5,
			["melee"] = 0.5,
		  },
		},
		["rogue"] = {
		  ["class"] = {
			["ROGUE"] = 1,
		  },
		},
		["everything"] = {
		  ["role"] = {
			["all"] = 1,
		  },
		},
		["engi"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["eng"] = 1,
		  },
		},
		["rhyo"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["beasts"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 0.75,
		  },
		},
		[l(bb["Akil'zon"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
		  },
		},
		["discipline"] = {
		  ["class"] = {
			["PRIEST"] = 1,
		  },
		},
		[l(bb["Mimiron"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["soulflayer"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["core"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 0.5,
		  },
		},
		["priest"] = {
		  ["class"] = {
			["PRIEST"] = 1,
		  },
		},
		["ony10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Ony"] = 1,
		  },
		},
		["damage"] = {
		  ["role"] = {
			["ranged"] = 0.5,
			["melee"] = 0.5,
		  },
		},
		["holy"] = {
		  ["class"] = {
			["PRIEST"] = 0.5,
			["PALADIN"] = 0.5,
		  },
		},
		["pally"] = {
		  ["class"] = {
			["PALADIN"] = 1,
		  },
		},
		["retribution"] = {
		  ["class"] = {
			["PALADIN"] = 1,
		  },
		},
		["valthalak"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		["cleave"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["3s"] = 0.75,
		  },
		},
		["death"] = {
		  ["class"] = {
			["DEATHKNIGHT"] = 0.5,
		  },
		},
		["knight"] = {
		  ["class"] = {
			["DEATHKNIGHT"] = 0.5,
		  },
		},
		["buru"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 1,
		  },
		},
		["blackwing"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 0.75,
			["BWL"] = 0.5,
		  },
		},
		["warr"] = {
		  ["class"] = {
			["WARRIOR"] = 1,
		  },
		},
		["cat"] = {
		  ["class"] = {
			["DRUID"] = 1,
		  },
		},
		["protection"] = {
		  ["class"] = {
			["PALADIN"] = 0.5,
			["WARRIOR"] = 0.5,
		  },
		},
		["yogg"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["arms"] = {
		  ["class"] = {
			["WARRIOR"] = 1,
		  },
		},
		["cuts"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 0.75,
		  },
		},
		["warrior"] = {
		  ["class"] = {
			["WARRIOR"] = 1,
		  },
		},
		["aran"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["hunter"] = {
		  ["class"] = {
			["HUNTER"] = 1,
		  },
		},
		["zanzil"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["bot25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		["lfw"] = {
		  ["type"] = {
			["lfw"] = 1,
		  },
		},
		["kitty"] = {
		  ["class"] = {
			["DRUID"] = 1,
		  },
		},
		[l(bb["Nalorakk"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
		  },
		},
		["boomkin"] = {
		  ["class"] = {
			["DRUID"] = 1,
		  },
		},
		["fury"] = {
		  ["class"] = {
			["WARRIOR"] = 1,
		  },
		},
		["drood"] = {
		  ["class"] = {
			["DRUID"] = 1,
		  },
		},
		["marrowgar"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		[l(bb["Gluth"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["goraluk"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		["reaver"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		["jcer"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 1,
		  },
		},
		[l(bb["Shazzrah"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		["feral"] = {
		  ["class"] = {
			["DRUID"] = 1,
		  },
		},
		["sartura"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["champs"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 0.75,
		  },
		},
		["firelands"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		[l(bb["Al'Akir"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TFW"] = 1,
		  },
		},
		["archimonde"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Hyj"] = 1,
		  },
		},
		[l(bb["Loatheb"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["crowd"] = {
		  ["role"] = {
			["cc"] = 0.25,
		  },
		},
		["kazrogal"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Hyj"] = 1,
		  },
		},
		["shahraz"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		[l(bb["Brutallus"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		["rs25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RS"] = 1,
		  },
		},
		["need"] = {
		  ["type"] = {
			["lfm"] = 0.5,
		  },
		},
		["tlr"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["tlr"] = 1,
		  },
		},
		["all"] = {
		  ["role"] = {
			["all"] = 0.5,
		  },
		},
		["rajaxx"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 1,
		  },
		},
		["blackhand"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		[l(bb["Thaddius"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		[l(bb["Magtheridon"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Mag"] = 1,
		  },
		},
		["anyone"] = {
		  ["role"] = {
			["all"] = 0.75,
		  },
		},
		["venoxis"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		[l(bb["Viscidus"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["melee"] = {
		  ["role"] = {
			["melee"] = 1,
		  },
		},
		["kael"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		["offtank"] = {
		  ["role"] = {
			["tank"] = 1,
		  },
		},
		["maintank"] = {
		  ["role"] = {
			["tank"] = 1,
		  },
		},
		["tanks"] = {
		  ["role"] = {
			["tank"] = 1,
		  },
		},
		["staghelm"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["disc"] = {
		  ["class"] = {
			["PRIEST"] = 1,
		  },
		},
		["dps"] = {
		  ["role"] = {
			["ranged"] = 0.5,
			["melee"] = 0.5,
		  },
		},
		[l(bb["Sapphiron"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["lair"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 0.5,
		  },
		},
		["lurker"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 0.75,
		  },
		},
		["wtb"] = {
		  ["type"] = {
			["lfprof"] = 0.25,
			["lfm"] = 0.25,
			["wtb"] = 1,
		  },
		},
		["rdps"] = {
		  ["role"] = {
			["ranged"] = 1,
			["melee"] = -1,
		  },
		},
		["lashlayer"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		["shammy"] = {
		  ["class"] = {
			["SHAMAN"] = 1,
		  },
		},
		["shadow"] = {
		  ["class"] = {
			["PRIEST"] = 1,
		  },
		},
		["5v5"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["5s"] = 1,
		  },
		},
		["to4w"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TFW"] = 1,
		  },
		},
		["halfus"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		["bmj"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Hyj"] = 1,
		  },
		},
		["2v2"] = {
		  ["type"] = {
["lfg"] = 1,
["lfm"] = 1,
},
["raid"] ={
			["2s"] = 1,
		  },
		},
		["huntard"] = {
		  ["class"] = {
			["HUNTER"] = 1,
		  },
		},
		["mag25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Mag"] = 1,
		  },
		},
		["ubrs"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		[l(bb["C'Thun"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["bot"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		[l(bb["Auriaya"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["maly"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["EoE"] = 1,
		  },
		},
		["tfw25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TFW"] = 1,
		  },
		},
		["cho"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		["conclave"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TFW"] = 1,
		  },
		},
		["chanter"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["enc"] = 1,
		  },
		},
		["tfw10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TFW"] = 1,
		  },
		},
		["bear"] = {
		  ["class"] = {
			["DRUID"] = 1,
		  },
		},
		["tfw"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TFW"] = 1,
		  },
		},
		["points"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["2s"] = 0.5,
			["3s"] = 0.5,
			["5s"] = 0.5,
		  },
		},
		["ins"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["ins"] = 1,
		  },
		},
		["opera"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["zandalari"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
			["ZG"] = 1,
		  },
		},
		["golemagg"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		[l(bb["Kalecgos"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		["exec"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 0.75,
		  },
		},
		["tgc"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 1,
		  },
		},
		["conquest"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["2s"] = 0.5,
			["3s"] = 0.5,
			["5s"] = 0.5,
		  },
		},
		[l(bb["Lucifron"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		[l(bb["Moam"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 1,
		  },
		},
		["arena"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["2s"] = 1,
			["3s"] = 1,
			["5s"] = 1,
		  },
		},
		[l(bb["Halion"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RS"] = 1,
		  },
		},
		["flag"] = {
		  ["role"] = {
			["tank"] = 0.5,
		  },
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 0.5,
		  },
		},
		["bt25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		["arenas"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["2s"] = 1,
			["3s"] = 1,
			["5s"] = 1,
		  },
		},
		["ubrs10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		["ther"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		[l(bb["Cho'gall"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		["rmp"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["3s"] = 0.75,
		  },
		},
		["ssc25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 1,
		  },
		},
		[l(bb["Ebonroc"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		["toc10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 1,
		  },
		},
		[l(bb["Argaloth"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},
		[l(bb["Grobbulus"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["ret"] = {
		  ["class"] = {
			["PALADIN"] = 1,
		  },
		},
		["icc25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["lf1m"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		[l(bb["Halazzi"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
		  },
		},
		["tidewalker"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 1,
		  },
		},
		["tailoring"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["tlr"] = 1,
		  },
		},
		[l(bb["Kologarn"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["eoe10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["EoE"] = 1,
		  },
		},
		[l(bb["Sinestra"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		[l(bb["Gehennas"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		[l(bb["Flamegor"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		[l(bb["Patchwerk"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["fankriss"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["eternity"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["EoE"] = 0.5,
		  },
		},
		["voa25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["VoA"] = 1,
		  },
		},
		["uld10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["anub"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 1,
		  },
		},
		["leviathan"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["algalon"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["queen"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 0.5,
		  },
		},
		["vezax"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		[l(bb["Razorscale"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["lfm"] = {
		  ["type"] = {
			["lfm"] = 1,
		  },
		},
		["assembly"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		[l(bb["Felmyst"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		[l(bb["Rotface"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		[l(bb["Malygos"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["EoE"] = 1,
		  },
		},
		["gunship"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		[l(bb["Thorim"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["lwer"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lw"] = 1,
		  },
		},
		["jaraxxus"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 1,
		  },
		},
		[l(bb["Onyxia"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Ony"] = 1,
		  },
		},
		["transmutation"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["alc"] = 0.5,
			["xm"] = 0.5,
		  },
		},
		[l(bb["Hodir"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["deconstructor"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["os3d"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["OS"] = 1,
		  },
		},
		["prot"] = {
		  ["class"] = {
			["PALADIN"] = 0.5,
			["WARRIOR"] = 0.5,
		  },
		},
		[l(bb["Supremus"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		["armorsmith"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["bs"] = 1,
		  },
		},
		[l(bb["Sartharion"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["OS"] = 1,
		  },
		},
		["horsemen"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["bot10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		[l(bz["Naxxramas"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["heigan"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		[l(bb["Kel'Thuzad"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["noth"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["emberseer"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		[l(bb["Maexxna"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		[l(bb["Anub'Rekhan"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["naxx"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["razuvious"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["maulgar"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["GL"] = 1,
		  },
		},
		[l(bz["Zul'Aman"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
		  },
		},
		["virtue"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		[l(bb["Kurinnaxx"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 1,
		  },
		},
		["kara10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		[l(bb["Moroes"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["chess"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["vashj"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 0.75,
		  },
		},
		["mc40"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		[l(bb["Nightbane"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		[l(bb["Netherspite"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["sunwell"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		["attumen"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["illhoof"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["kz10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["hydross"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 1,
		  },
		},
		["malchezaar"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["illidari"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		["sunstrider"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		[l(bb["Chimaeron"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 1,
		  },
		},
		["bwd10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 1,
		  },
		},
		[l(bb["Entropius"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		["uld"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["domo"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 0.5,
			["FL"] = 0.75,
		  },
		},
		["healer"] = {
		  ["role"] = {
			["healer"] = 1,
		  },
		},
		["leotheras"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 1,
		  },
		},
		["cutting"] = {
		  ["type"] = {
			["lfw"] = 1,
		  },
		},
		["temple"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 0.5,
			["BT"] = 0.75,
		  },
		},
		["voa"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["VoA"] = 1,
		  },
		},
		[l(bb["Ragnaros"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 0.5,
			["FL"] = 0.75,
		  },
		},
		["tank"] = {
		  ["role"] = {
			["tank"] = 1,
		  },
		},
		["toravon"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["VoA"] = 1,
		  },
		},
		["solarian"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		["alc"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["alc"] = 1,
		  },
		},
		["sathrovarr"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		["sandworm"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["aq40"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["bmj25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Hyj"] = 1,
		  },
		},
		[l(bb["Nefarian"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 0.75,
			["BWL"] = 0.5,
		  },
		},
		["rated"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 0.5,
			["2s"] = 0.25,
			["3s"] = 0.25,
			["5s"] = 0.25
		  },
		},
		["rating"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 0.5,
			["2s"] = 0.5,
			["3s"] = 0.5,
			["5s"] = 0.5
		  },
		},
		["mmr"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RBG"] = 0.5,
			["2s"] = 0.5,
			["3s"] = 0.5,
			["5s"] = 0.5
		  },
		},
		["citadel"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 0.5,
		  },
		},
		["blacksmith"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["bs"] = 1,
		  },
		},
		["elixir"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["alc"] = 0.5,
			["em"] = 0.5,
		  },
		},
		["xmute"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["alc"] = 0.5,
			["xm"] = 0.5,
		  },
		},
		["transmute"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["alc"] = 0.5,
			["xm"] = 0.5,
		  },
		},
		["master"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["pm"] = 0.5,
			["em"] = 0.5,
			["xm"] = 0.5,
		  },
		},
		["inscriber"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["ins"] = 1,
		  },
		},
		["ele"] = {
		  ["class"] = {
			["SHAMAN"] = 1,
		  },
		},
		["mdps"] = {
		  ["role"] = {
			["ranged"] = -1,
			["melee"] = 1,
		  },
		},
		["ml25"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Mag"] = 1,
		  },
		},
		[l(bb["Freya"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["gyth"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		["leatherworker"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lw"] = 1,
		  },
		},
		["executus"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		[l(bb["Magmadar"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 1,
		  },
		},
		[l(bz["Karazhan"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Kra"] = 1,
		  },
		},
		["rs10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["RS"] = 1,
		  },
		},
		["pala"] = {
		  ["class"] = {
			["PALADIN"] = 1,
		  },
		},
		["control"] = {
		  ["role"] = {
			["cc"] = 0.25,
		  },
		},
		["ossirian"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 1,
		  },
		},
		["vaelastrasz"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		["gothik"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Nax"] = 1,
		  },
		},
		["work"] = {
		  ["type"] = {
			["lfw"] = 1,
		  },
		},
		["ony"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Ony"] = 1,
		  },
		},
		["archavon"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["VoA"] = 1,
		  },
		},
		["emalon"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["VoA"] = 1,
		  },
		},
		["jewel"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 0.5,
		  },
		},
		[l(bb["Anub'arak"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 1,
		  },
		},
		["jed"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		["koralon"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["VoA"] = 1,
		  },
		},
		[l(bb["Gahz'ranka"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["alchemist"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["alc"] = 1,
		  },
		},
		["voa10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["VoA"] = 1,
		  },
		},
		["weaponsmith"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["bs"] = 1,
		  },
		},
		[l(bb["Maloriak"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 1,
		  },
		},
		[l(bz["Ulduar"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["anything"] = {
		  ["role"] = {
			["all"] = 0.5,
		  },
		},
		["any"] = {
		  ["type"] = {
			["lfprof"] = 0.5,
		  },
		},
		["alys"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["FL"] = 1,
		  },
		},
		["deathknight"] = {
		  ["class"] = {
			["DEATHKNIGHT"] = 1,
		  },
		},
		["looking"] = {
		  ["type"] = {
			["lfm"] = 0.5,
			["lfprof"] = 0.5,
			["lfg"] = 0.5,
		  },
		},
		[l(bz["Zul'Gurub"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["jindo"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["bloodboil"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		["molten"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["MC"] = 0.75,
		  },
		},
		["bwl"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWL"] = 1,
		  },
		},
		["bh10"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BH"] = 1,
		  },
		},
		["omnotron"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 1,
		  },
		},
		["enchanter"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["enc"] = 1,
		  },
		},
		["bwd"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BWD"] = 1,
		  },
		},
		["enchant"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["enc"] = 1,
		  },
		},
		["putricide"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["jenalai"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZA"] = 1,
		  },
		},
		["eredar"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SWP"] = 1,
		  },
		},
		["emperors"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 0.75,
		  },
		},
		["eng"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["eng"] = 1,
		  },
		},
		["serpentshrine"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 1,
		  },
		},
		["comp"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["2s"] = 0.5,
			["3s"] = 0.75,
			["5s"] = 0.5,
		  },
		},
		["karathress"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 1,
		  },
		},
		["group"] = {
		  ["type"] = {
			["lfg"] = 0.5,
		  },
		},
		["reliquary"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BT"] = 1,
		  },
		},
		["partner"] = {
		  ["type"] = {
			["lfm"] = 1,
			["lfg"] = 1,
		  },
		  ["raid"] = {
			["2s"] = 1,
		  }
		},
		["drakkisath"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["UBRS"] = 1,
		  },
		},
		["ignis"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Uld"] = 1,
		  },
		},
		["deathwhisper"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		[l(bb["Ouro"])] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ40"] = 1,
		  },
		},
		["crafting"] = {
		  ["type"] = {
			["lfw"] = 1,
		  },
		},
		["scribe"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["ins"] = 1,
		  },
		},
		["kaelthas"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["TK"] = 1,
		  },
		},
		["dreamwalker"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["winterchill"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Hyj"] = 1,
		  },
		},
		["inscriptions"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["ins"] = 1,
		  },
		},
		["twins"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ToC"] = 0.75,
		  },
		},
		["shaman"] = {
		  ["class"] = {
			["SHAMAN"] = 1,
		  },
		},
		["ssc"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["SSC"] = 1,
		  },
		},
		["arlokk"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ZG"] = 1,
		  },
		},
		["mage"] = {
		  ["class"] = {
			["MAGE"] = 1,
		  },
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["Mag"] = -1,
		  },
		},
		["valiona"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["BoT"] = 1,
		  },
		},
		["cutter"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["jc"] = 0.5,
		  },
		},
		["engineer"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["eng"] = 1,
		  },
		},
		["lich"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["ICC"] = 1,
		  },
		},
		["potion"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["alc"] = 0.5,
			["pm"] = 0.5,
		  },
		},
		["pot"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["alc"] = 0.5,
			["pm"] = 0.5,
		  },
		},
		["ayamiss"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["AQ10"] = 1,
		  },
		},
		["eye"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["EoE"] = 0.5,
		  },
		},
		["crafter"] = {
		  ["type"] = {
["lfprof"] = 0.5,
["lfw"] = 0.25,
},
		},
		["sarth"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["OS"] = 1,
		  },
		},
		["3v3"] = {
		  ["type"] = {
["lfg"] = 0.25,
["lfm"] = 0.25,
},
["raid"] ={
			["3s"] = 1,
		  },
		},
		["guild"] = {
		  ["type"] = {
		    ["lfguild"] = 0.5,
			["guildlfm"] = 0.1,
		  }
		},
		["recruit"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["recruiting"] = {
		  ["type"] = {
			["guildlfm"] = 1.5,
		  },
		},
		["apply"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["members"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["players"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["level"] = {
		  ["type"] = {
			["guildlfm"] = 0.75,
			["lfguild"] = 0.75,
		  },
		},
		["lvl"] = {
		  ["type"] = {
			["guildlfm"] = 0.75,
			["lfguild"] = 0.75,
		  },
		},
		["ilevel"] = {
		  ["type"] = {
			["lfg"] = 0.5,
			["lfm"] = 1,
		  },
		},
		["ilvl"] = {
		  ["type"] = {
			["lfg"] = 0.5,
			["lfm"] = 1,
		  },
		},
		["grow"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["info"] = {
		  ["type"] = {
			["guildlfm"] = 0.5,
		  },
		},
		["core"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["casual"] = {
		  ["type"] = {
			["lfguild"] = 0.5,
			["guildlfm"] = 0.5,
		  },
		},
		["social"] = {
		  ["type"] = {
			["lfguild"] = 0.5,
			["guildlfm"] = 0.5,
		  },
		},
		["raiding"] = {
		  ["type"] = {
			["lfguild"] = 0.5,
			["guildlfm"] = 0.5,
		  },
		},
		["pvp"] = {
		  ["type"] = {
			["lfguild"] = 1,
			["guildlfm"] = 0.5,
		  },
		},
		["wowstead"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["guildlaunch"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["guildzilla"] = {
		  ["type"] = {
			["guildlfm"] = 1,
		  },
		},
		["raid"] ={
		  ["type"] = {
		    ["lfg"] = 0.5,
		    ["guildlfm"] = 0.5,
		  },
		},
		["pal"] = {
		  ["class"] = {
			["PALADIN"] = 0.5,
		  },
		},
		["hpal"] = {
		  ["class"] = {
			["PALADIN"] = 1,
		  },
		},
		["port"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["port"] = 1,
		  },
		},
		["portal"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["port"] = 1,
		  },
		},
		[l(bi["Cooking"])] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["co"] = 1,
		  },
		},
		["cook"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["co"] = 1,
		  },
		},
		[l(GetSpellInfo(2656))] = {
		  ["type"] = {
		["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["sm"] = 1,
		  },
		},
		["smelt"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["sm"] = 1,
		  },
		},
		["smelter"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["sm"] = 1,
		  },
		},
		["miner"] = {
		  ["type"] = {
["lfprof"] = 0.25,
},
["prof"] = {
			["sm"] = 0.5,
		  },
		},
		["summon"] = {
		  ["type"] = {
["lfprof"] = 0.25,
},
["prof"] = {
			["hgwt"] = 1,
		  },
		},
		["fly"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["fly"] = 0.5,
		  },
		},
		["ride"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["fly"] = 1,
		  },
		},
		["fly"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["fly"] = 0.5,
		  },
		},
		["open"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lp"] = 1,
		  },
		},
		["opening"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lp"] = 1,
		  },
		},
		["unlock"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lp"] = 1,
		  },
		},
		["lockbox"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lp"] = 1,
		  },
		},
		["locksmith"] = {
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lp"] = 1,
		  },
		},
		[l(GetSpellInfo(6460))] = { --Lockpicking
		  ["type"] = {
["lfprof"] = 0.25,
["lfw"] = 0.25,
},
["prof"] = {
			["lp"] = 1,
		  },
		},
		["vent"] = {
		  ["type"] = {
			["lfg"] = 0.5,
			["lfm"] = 0.5,
		  },
		},
	  }
	}

end
